package  scenes{
	import jp.progression.*;
	import jp.progression.casts.*;
	import jp.progression.casts.mx.*;
	import jp.progression.commands.*;
	import jp.progression.commands.display.*;
	import jp.progression.commands.lists.*;
	import jp.progression.commands.net.*;
	import jp.progression.commands.tweens.*;
	import jp.progression.data.*;
	import jp.progression.events.*;
	import jp.progression.loader.*;
	import jp.progression.scenes.*;
	
	import mx.collections.ArrayCollection;
	import mx.controls.DataGrid;
	
	/**
	 * ...
	 * @author ...
	 */
	public class DataGridScene extends SceneObject {
		private var _dataGrid:DataGrid;
		
		/**
		 * 新しい MySceneObject インスタンスを作成します。
		 */
		public function DataGridScene( name:String = null, initObject:Object = null ) {
			// 親クラスを初期化する
			super( name, initObject );
			
			// シーンタイトルを設定します。
			title = "DataGrid";
		}
		
		/**
		 * シーンオブジェクト自身が目的地だった場合に、到達した瞬間に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneInit():void {
			
			// データグリッドを作成
			_dataGrid = new DataGrid();
			_dataGrid.alpha = 0; // 演出用に透明度を0に
			_dataGrid.width = 640;
			_dataGrid.height = 480;
			// データのセット
			_dataGrid.dataProvider = new ArrayCollection([
				{label : "りんご", price : "200円"},
				{label : "みかん", price : "500円"},
				{label : "いちご", price : "400円"},
				{label : "ぶどう", price : "300円"},
				{label : "きゅうい", price : "200円"},
				]);
			
			addCommand(
				// 表示
				new AddChild(container, _dataGrid),
				// 演出
				new DoTweener(_dataGrid, {alpha:1, time:1, transition:"easeNone"})
			);
		}
		
		/**
		 * シーンオブジェクト自身が出発地だった場合に、移動を開始した瞬間に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneGoto():void {
			addCommand(
				// 演出
				new DoTweener(_dataGrid, {alpha:0, time:1, transition:"easeNone"}),
				new Func(function():void{
					// 非表示
					container.removeChild(_dataGrid);
					// 参照をnull
					_dataGrid = null;
				})
			);
		}
	}
}
