﻿package  scenes{
	import flash.net.URLRequest;
	
	import jp.progression.*;
	import jp.progression.casts.*;
	import jp.progression.casts.mx.*;
	import jp.progression.commands.*;
	import jp.progression.commands.display.*;
	import jp.progression.commands.lists.*;
	import jp.progression.commands.net.*;
	import jp.progression.commands.tweens.*;
	import jp.progression.data.*;
	import jp.progression.events.*;
	import jp.progression.loader.*;
	import jp.progression.scenes.*;
	
	import mx.controls.RichTextEditor;
	import mx.managers.CursorManager;
	
	/**
	 * ...
	 * @author ...
	 */
	public class RichTextScene extends SceneObject {
		private var _editor:RichTextEditor;
		
		/**
		 * 新しい MySceneObject インスタンスを作成します。
		 */
		public function RichTextScene( name:String = null, initObject:Object = null ) {
			// 親クラスを初期化する
			super( name, initObject );
			
			// シーンタイトルを設定します。
			title = "RichTextEditor";
		}
		
		/**
		 * シーンオブジェクト自身が目的地だった場合に、到達した瞬間に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneInit():void {
			
			// リッチテキストエディターを作成
			_editor = new RichTextEditor();
			_editor.alpha = 0; // 演出用に透明度を0に
			
			// 読み込み処理のためビジーカーソルにする
			CursorManager.setBusyCursor();
			
			addCommand(
				// 外部ファイル読み込み
				new LoadURL(new URLRequest("data/sample.txt")),
				new Func(function():void{
					// ビジーカーソルの解除
					CursorManager.removeBusyCursor();
					// 読み込んだ外部ファイルをエディターにセット
					_editor.htmlText = this.latestData;
				}),
				// 表示
				new AddChild(container, _editor),
				// 演出
				new DoTweener(_editor, {alpha:1, time:1, transition:"easeNone"})
			);
		}
		
		/**
		 * シーンオブジェクト自身が出発地だった場合に、移動を開始した瞬間に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneGoto():void {
			addCommand(
				// 演出
				new DoTweener(_editor, {alpha:0, time:1, transition:"easeNone"}),
				new Func(function():void{
					// 非表示
					container.removeChild(_editor);
					// 参照をnull
					_editor = null;
				})
				);
		}
	}
}
